/*2016/09/20
 * App part: "Type Select" OK,  "Rhythm" OK, "Chord" OK.
 * Five mode.
 * For DU-ONE, No Pizeo version.
 */
/*====================All Area BEGIN====================================*/
#include <SoftwareSerial.h>
#include "Setup.h"

#include <avr/pgmspace.h>
#include <EEPROM.h>
//EEPROM define
int EE_Value;
int BT_return = 0;

//Get Neck
int Neck = 1023;
boolean testVR1 = LOW, testVR2 = LOW, testVR3 = LOW, testVR4 = LOW;

SoftwareSerial Dream(14,15); //Rx,Tx
unsigned long WatchDog = 0; //BackGround & Tempo
int BackGround = 0; //BackGround

int Note_Datum; //Tempo

int countVR1 =0,countVR2=0,countVR3=0,countVR4=0; //Tempo

int Volume_old = 0; //Volume
const int Volume_limit = 2;

int Voice_old = 0; //Voice
char MIDI; //Voice
const int Voice_limit = 4;
const int Voice_0 = 20, Voice_1 = 100,Voice_2 = 200,Voice_3 = 300,Voice_4 = 420,Voice_5 = 520,Voice_6 = 650,Voice_7 = 800,Voice_8 = 900;

int Mode = 0; //Mode
const int Mode_VR_0 = 15,Mode_VR_1 = 100,Mode_VR_2 = 200,Mode_VR_3 = 300,Mode_VR_4 = 400;

int T1,T2,T3,T4; //FSR
int FSR1_old = 0, FSR2_old = 0, FSR3_old = 0, FSR4_old = 0; //FSR
int VR1_old = 0, VR2_old = 0, VR3_old = 0, VR4_old = 0; //FSR
const int Trick = 800;//limit of Trick FSR //1015
unsigned long Time_1 = 0,Time_2 = 0,Time_3 = 0,Time_4 = 0; //FSR
int count_1 = 0, count_2 = 0, count_3 = 0,count_4 = 0; // FSR
boolean cut_note1 = HIGH,cut_note2 = HIGH,cut_note3 = HIGH,cut_note4 = HIGH; //FSR
int T1_old = 0x45,T2_old=0x40,T3_old=0x3C,T4_old=0x43; //FSR default

//Mode 1 Setting
int UPflag_1 = 0, UPflag_2 = 0, UPflag_3 = 0, UPflag_4 = 0; 
int DWflag_1 = 0, DWflag_2 = 0, DWflag_3 = 0, DWflag_4 = 0; 

//Mode 2 Setting
int V1,V2,V3,V4; //FSR Mode_2
boolean Mode2_1 = LOW,Mode2_2=LOW,Mode2_3=LOW,Mode2_4=LOW; //FSR Mode_2
const int Mode2Trick = 100; //Trick Mode 2  //FSR Mode_2
const int Mode2Interval = 100; //Mode 2 interval   //FSR Mode_2

//Mode 3 Setting
int T1_Mode4_1, T1_Mode4_2, T1_Mode4_3,T2_Mode4_1,T2_Mode4_2,T2_Mode4_3;
int T3_Mode4_1,T3_Mode4_2,T3_Mode4_3,T4_Mode4_1,T4_Mode4_2,T4_Mode4_3;
boolean Mode4_flag1 = LOW,Mode4_flag2 = LOW,Mode4_flag3 = LOW, Mode4_flag4 = LOW;
int Mode4_count1 = 0, Mode4_count2=0, Mode4_count3=0, Mode4_count4=0;

//Mode 4 Setting
unsigned long Time_BD; 
const int BD = 60; 
int Velocity_BD;

//VR setting
//UKULELE
int Null[4]={0x45,0x40,0x3C,0x43}; //69,64,60,67  //Null String(空弦)
int Array[4][17]; //Chord set
int MIDI_0 = 24,MIDI_1=29,MIDI_2=39,MIDI_3=0,MIDI_4=57,MIDI_5=50,MIDI_6=76,MIDI_7=63,MIDI_8=106,MIDI_9=46;

//For BLE
int BT_count = 0; //計算APP傳3碼後歸零
int BT_message[3] = {255,255,255};
boolean BT_flag = LOW; //HIGH的話代表APP有傳訊息。

//Rhythm Setting
int BT_Rhythm_Count = 0;
int PlayCount =0;
unsigned long PlayTime;
boolean BT_Rhythm1 = LOW, BT_Rhythm2 = LOW, BT_Rhythm3 = LOW, BT_Rhythm4 = LOW;
int Tempo_Speed = 120; //Tempo
int Rhythm1_Drum1[30] = {42,42,42,0,42};
int Rhythm1_Drum2[30] = {36,40,36,36,40};
int Rhythm1_Tempo[30] = {4,4,8,8,4};
int Rhythm1_Nm = 5;

int Rhythm2_Drum1[30] = {42,42,42,42,42,42,42,42};
int Rhythm2_Drum2[30] = {36,0,40,36,36,0,40,0};
int Rhythm2_Tempo[30] = {8,8,8,8,8,8,8,8};
int Rhythm2_Nm = 8;

int Rhythm3_Drum1[30] = {42,42,42,42,42,42,42,42};
int Rhythm3_Drum2[30] = {36,0,0,0,40,0,0,0};
int Rhythm3_Tempo[30] = {16,16,16,16,16,16,16,16};
int Rhythm3_Nm = 8;

int Rhythm4_Drum1[30] = {42,42,42,42,42,42};
int Rhythm4_Drum2[30] = {36,0,0,40,0,0};
int Rhythm4_Tempo[30] = {3,3,3,3,3,3};
int Rhythm4_Nm = 6;

boolean Rhythm1_Flag = LOW, Rhythm2_Flag = LOW, Rhythm3_Flag = LOW, Rhythm4_Flag = LOW;



const int LED = 13;
const int Dream_tx = 11;
const int Ch10_ON = 0x99;
const int Ch10_OFF = 0x89;

const int Ch1_ON = 0x90;
const int Ch1_OFF = 0x80;

const int Velocity = 127;
const int ON = 127;
const int OFF = 0;
const int CurrentTime = 70;//avoid to multi tricks
//go limit
const int Ctrl = 0xB0;

const int Zero = 0;
const int down = 12; //升降8度


int FstString_1 = 48, SecString_1 = 55, ThrString_1 = 60, ForString_1 = 64; //C
int FstString_2 = 50, SecString_2 = 57, ThrString_2 = 62, ForString_2 = 65; //Dm
int FstString_3 = 52, SecString_3 = 59, ThrString_3 = 64, ForString_3 = 67; //Em
int FstString_4 = 41, SecString_4 = 48, ThrString_4 = 53, ForString_4 = 57; //F
int FstString_5 = 43, SecString_5 = 50, ThrString_5 = 55, ForString_5 = 59; //G
int FstString_6 = 45, SecString_6 = 52, ThrString_6 = 57, ForString_6 = 60; //Am
int FstString_7 = 47, SecString_7 = 53 ,ThrString_7 = 59, ForString_7 = 62; //Bm*/

//go message define
//For tempo String
int msgA= 0, msgB =0, msgC=0,msgD= 0;

int First_old = 1023;
int Second_old = 1023;
int Third_old = 1023;
int Fourth_old = 1023;
int VR1,VR2,VR3,VR4;

//BLE回傳
int Chord_count = 0;
int Rhythm_count = 0;
int Chord_1=60,Chord_2=62,Chord_3=64, Chord_4=65, Chord_5=67, Chord_6=69, Chord_7=71, Chord_8, Chord_9, Chord_10;
int Rhythm_1 =60, Rhythm_2=1, Rhythm_3=1, Rhythm_4=1, Rhythm_5=1;

int Chord[10] = {Chord_1, Chord_2, Chord_3, Chord_4, Chord_5, Chord_6, Chord_7, Chord_8, Chord_9, Chord_10};
int Rhythm[5] = {Rhythm_1, Rhythm_2, Rhythm_3, Rhythm_4, Rhythm_5};

/*====================All Area END======================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*====================Setup BEGIN====================================*/
void setup(){ 
  Serial.begin(57600); 
  Serial1.begin(57600);
  Dream.begin(31250); 
  
  for (int i=0;i < 10; i++){
    pinMode(i, INPUT);
  }

  pinMode(11,OUTPUT); //Dream's Tx out
  pinMode(13,OUTPUT); //LED POWER
}
/*====================Steup END======================================*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*====================Loop BEGIN====================================*/
void loop(){
 //以下順序請勿更動, 否則琴頸讀值會亂
  int VR2 = analogRead(9); //Chord Position  New:8  / Old:9
  int VR3 = analogRead(8); //Chord Position  New:9 / Old:8
  int VR4 = analogRead(7); //Chord Position New:10/ Old:7
  int VR1 = analogRead(10); //Chord Position  New:7 / Old:10
  
  int Voice = analogRead(5); //New = 5 //Voice
  int Vol = analogRead(6); //Volume 
  int Mode_VR = analogRead(4); //New = 4 //Mode

  int BodyDrum = analogRead(11);

  int FSR3 = analogRead(1);
  int FSR4 = analogRead(0);
  int FSR1 = analogRead(3);
  int FSR2 = analogRead(2);

  const int Velocity1 = 127;
  const int Velocity2 = 127;
  const int Velocity3 = 127;
  const int Velocity4 = 127;
  
  int Volume = map(Vol, 0, 1023, 0, 127); //Volume

//->BackGround Set
  while ((millis() - WatchDog >= 100) && (BackGround == 0)){
     
    midiSend(Ctrl, 0x63, 0x37); //Aux on
    midiSend(Ctrl, 0x62, 0x5F);
    midiSend(Ctrl, 0x06, 0x37);

    if(Voice <= Voice_0){ MIDI = MIDI_0;}  //~20
    else if(Voice > Voice_0 && Voice <= Voice_1){ MIDI = MIDI_1;} //20~100
    else if(Voice > Voice_1 && Voice <= Voice_2){ MIDI = MIDI_2;} //100~200
    else if(Voice > Voice_2 && Voice <= Voice_3){ MIDI = MIDI_3;} //200~300
    else if(Voice > Voice_3 && Voice <= Voice_4){ MIDI = MIDI_4;} //300~420
    else if(Voice > Voice_4 && Voice <= Voice_5){ MIDI = MIDI_5;} //420~520
    else if(Voice > Voice_5 && Voice <= Voice_6){ MIDI = MIDI_6;} //520~650
    else if(Voice > Voice_6 && Voice <= Voice_7){ MIDI = MIDI_7;} //650~800
    else if(Voice > Voice_7 && Voice <= Voice_8){ MIDI = MIDI_8;} //800~900
    else if(Voice > Voice_8){ MIDI = MIDI_9;}  //900~
    
    ProgramChange(192,MIDI);

    midiSend(Ctrl, 0x63, 0x37);
    midiSend(Ctrl, 0x62, 0x22);
    midiSend(Ctrl, 0x06, Volume); 
     
    WatchDog = millis();

    digitalWrite(LED, HIGH); //POWER LED ON
    
    for (int i = 0; i < 4; i++){ //Chord String Set
      for (int j = 0; j < 17; j++){
        Array[i][j] = Null[i] + j;
      }
    }
    BackGround = 1; //只跑一次
    
  }//BackGround set end

//->Mode
  if (Mode_VR < Mode_VR_0){ Mode = 1;} //~15
  else if ((Mode_VR >=Mode_VR_0 ) && (Mode_VR < Mode_VR_1)){ Mode = 2; } //15~100
  else if ((Mode_VR >=Mode_VR_1 ) && (Mode_VR < Mode_VR_2)){ Mode = 3; } //100~200
  else if ((Mode_VR >= Mode_VR_2 ) && ( Mode_VR < Mode_VR_3)){ Mode = 4; } //200~300
  else if (Mode_VR >= Mode_VR_3){ Mode = 5; } //300~400
  
//->Volume
  if (abs(Volume - Volume_old) > Volume_limit){
    Volume_old = Volume;
    midiSend(Ctrl, 0x63, 0x37);
    midiSend(Ctrl, 0x62, 0x22);
    midiSend(Ctrl, 0x06, Volume); 
  }
  
//->Voice
  if (abs(Voice - Voice_old) > Voice_limit ){
    if(Voice <= Voice_0){ MIDI = MIDI_0;} //~20
    else if(Voice > Voice_0 && Voice <= Voice_1){ MIDI = MIDI_1;} //20~100
    else if(Voice > Voice_1 && Voice <= Voice_2){ MIDI = MIDI_2;} //100~200
    else if(Voice > Voice_2 && Voice <= Voice_3){ MIDI = MIDI_3;} //200~300
    else if(Voice > Voice_3 && Voice <= Voice_4){ MIDI = MIDI_4;} //300~420
    else if(Voice > Voice_4 && Voice <= Voice_5){ MIDI = MIDI_5;} //420~520
    else if(Voice > Voice_5 && Voice <= Voice_6){ MIDI = MIDI_6;} //520~650
    else if(Voice > Voice_6 && Voice <= Voice_7){ MIDI = MIDI_7;} //650~800
    else if(Voice > Voice_7 && Voice <= Voice_8){ MIDI = MIDI_8;} //800~900
    else if(Voice > Voice_8){ MIDI = MIDI_9;}  //900~
    Voice_old = Voice;
    ProgramChange(192,MIDI); //改音色
    SustainSet(MIDI); //根據不同音色來修正延音
  }

//->Chord Position Set
 if(VR1 < Seventeen_1){
    if(countVR1 == 0){
      countVR1 ++;
      if (Rhythm1_Flag == HIGH){ Rhythm1_Flag = LOW;}
      else if (Rhythm1_Flag == LOW){ Rhythm1_Flag = HIGH; DefaultSet(); 
        Rhythm2_Flag = Rhythm3_Flag = Rhythm4_Flag = LOW;
      }
    }
  }
  else if(VR1 < Sixteen_1){ T1 = Array[0][16]; }
  else if(VR1 < Fifteen_1){ T1= Array[0][15];}
  else if(VR1 < Fourteen_1){T1= Array[0][14];}
  else if(VR1 < Thirteen_1){T1= Array[0][13];}
  else if(VR1 < Twelve_1){T1= Array[0][12];}
  else if(VR1 < Eleven_1){T1= Array[0][11];}
  else if(VR1 < Ten_1){T1= Array[0][10];}
  else if(VR1 < Nine_1){T1= Array[0][9];}
  else if(VR1 < Eight_1){T1= Array[0][8];}
  else if(VR1 < Seven_1){T1= Array[0][7];}
  else if(VR1 < Six_1){T1= Array[0][6];}
  else if(VR1 < Five_1){T1= Array[0][5];}
  else if(VR1 < Four_1){T1= Array[0][4];}
  else if(VR1 < Three_1){T1= Array[0][3];}
  else if(VR1 < Two_1){T1= Array[0][2];}
  else if(VR1 < One_1){T1= Array[0][1];}
  else{T1= Array[0][0]; countVR1 = 0; } //Tempo防重複觸發

  if(VR2 < Seventeen_2){
    if(countVR2 ==0){
      countVR2 ++;
      if (Rhythm2_Flag == HIGH){ Rhythm2_Flag = LOW;}
      else if (Rhythm2_Flag == LOW){ Rhythm2_Flag = HIGH; DefaultSet(); 
        Rhythm1_Flag = Rhythm3_Flag = Rhythm4_Flag = LOW;
      }
    }
  }
  
  else if(VR2 < Sixteen_2){ T2 = Array[1][16]; }
  else if(VR2 < Fifteen_2){ T2= Array[1][15];}
  else if(VR2 < Fourteen_2){T2= Array[1][14];}
  else if(VR2 < Thirteen_2){T2= Array[1][13];}
  else if(VR2 < Twelve_2){T2= Array[1][12];}
  else if(VR2 < Eleven_2){T2= Array[1][11];}
  else if(VR2 < Ten_2){T2= Array[1][10];}
  else if(VR2 < Nine_2){T2= Array[1][9];}
  else if(VR2 < Eight_2){T2= Array[1][8];}
  else if(VR2 < Seven_2){T2= Array[1][7];}
  else if(VR2 < Six_2){T2= Array[1][6];}
  else if(VR2 < Five_2){T2= Array[1][5];}
  else if(VR2 < Four_2){T2= Array[1][4];}
  else if(VR2 < Three_2){T2= Array[1][3];}
  else if(VR2 < Two_2){T2= Array[1][2];}
  else if(VR2 < One_2){T2= Array[1][1];}
  else{T2= Array[1][0];countVR2 = 0; } //Tempo防重複觸發
  
  if(VR3 < Seventeen_3){ 
    if(countVR3 ==0){
      countVR3 ++;
      if (Rhythm3_Flag == HIGH){ Rhythm3_Flag = LOW;}
      else if (Rhythm3_Flag == LOW){ Rhythm3_Flag = HIGH; DefaultSet(); 
        Rhythm2_Flag = Rhythm1_Flag = Rhythm4_Flag = LOW;
      }
    }
  }
  
  else if(VR3 < Sixteen_3){ T3 = Array[2][16]; }
  else if(VR3 < Fifteen_3){ T3= Array[2][15];}
  else if(VR3 < Fourteen_3){T3= Array[2][14];}
  else if(VR3 < Thirteen_3){T3= Array[2][13];}
  else if(VR3 < Twelve_3){T3= Array[2][12];}
  else if(VR3 < Eleven_3){T3= Array[2][11];}
  else if(VR3 < Ten_3){T3= Array[2][10];}
  else if(VR3 < Nine_3){T3= Array[2][9];}
  else if(VR3 < Eight_3){T3= Array[2][8];}
  else if(VR3 < Seven_3){T3= Array[2][7];}
  else if(VR3 < Six_3){T3= Array[2][6];}
  else if(VR3 < Five_3){T3= Array[2][5];}
  else if(VR3 < Four_3){T3= Array[2][4];}
  else if(VR3 < Three_3){T3= Array[2][3];}
  else if(VR3 < Two_3){T3= Array[2][2];}
  else if(VR3 < One_3){T3= Array[2][1];}
  else{T3 = Array[2][0];countVR3 = 0; } //Tempo防重複觸發

  if(VR4 < Seventeen_4){ 
    if(countVR4 ==0){
      countVR4 ++;
      if (Rhythm4_Flag == HIGH){ Rhythm4_Flag = LOW;}
      else if (Rhythm4_Flag == LOW){ Rhythm4_Flag = HIGH; DefaultSet(); 
        Rhythm2_Flag = Rhythm3_Flag = Rhythm1_Flag = LOW;
      }
    }
  }
  
  else if(VR4 < Sixteen_4){ T4 = Array[3][16];  }
  else if(VR4 < Fifteen_4){ T4= Array[3][15];}
  else if(VR4 < Fourteen_4){T4= Array[3][14];}
  else if(VR4 < Thirteen_4){T4= Array[3][13];}
  else if(VR4 < Twelve_4){T4= Array[3][12];}
  else if(VR4 < Eleven_4){T4= Array[3][11];}
  else if(VR4 < Ten_4){T4= Array[3][10];}
  else if(VR4 < Nine_4){T4= Array[3][9];} 
  else if(VR4 < Eight_4){T4= Array[3][8];} 
  else if(VR4 < Seven_4){T4= Array[3][7];} 
  else if(VR4 < Six_4){T4= Array[3][6];} 
  else if(VR4 < Five_4){T4= Array[3][5];}
  else if(VR4 < Four_4){T4= Array[3][4];}
  else if(VR4 < Three_4){T4= Array[3][3];}
  else if(VR4 < Two_4){T4= Array[3][2];} 
  else if(VR4 < One_4){T4= Array[3][1];} 
  else{T4= Array[3][0];countVR4 = 0; }//Tempo防重複觸發





//-> BLE Communications protocol
if (Serial1.available() > 0){
  int BT_Value = Serial1.read();
 // Serial.println(BT_Value);
  BT_message[BT_count] = BT_Value;
  BT_count ++;
  if (BT_count == 3){ 
    BT_count = 0; BT_flag = HIGH;
    //節拍速度更改
      if ((BT_message[0] == 2) && (BT_message[1] == 0) ){
        Tempo_Speed = BT_message[2];
      }
      //檢查是否接收到藍芽節奏修改
      if ((BT_Rhythm1 == HIGH) &&(BT_message[1] == 1) && (BT_message[2] == 255)){ BT_Rhythm1 = LOW; Rhythm1_Nm = BT_Rhythm_Count; DefaultSet();}
      if (BT_Rhythm1 == HIGH){
        Rhythm1_Drum1[BT_Rhythm_Count] = BT_message[0];
        Rhythm1_Drum2[BT_Rhythm_Count] = BT_message[1];
        Rhythm1_Tempo[BT_Rhythm_Count] = BT_message[2];

        BT_Rhythm_Count ++;
      }
      if (( BT_message[0] == 2)  && (BT_message[1] == 1) && (BT_message[2] == 254)){ BT_Rhythm1 = HIGH; BT_Rhythm_Count =0; BT_flag = LOW;}

      if ((BT_Rhythm2 == HIGH) &&(BT_message[1] == 2) && (BT_message[2] == 255)){ BT_Rhythm2 = LOW; Rhythm2_Nm = BT_Rhythm_Count; DefaultSet();}
      if (BT_Rhythm2 == HIGH){
        Rhythm2_Drum1[BT_Rhythm_Count] = BT_message[0];
        Rhythm2_Drum2[BT_Rhythm_Count] = BT_message[1];
        Rhythm2_Tempo[BT_Rhythm_Count] = BT_message[2];

        BT_Rhythm_Count ++;
      }
      if (( BT_message[0] == 2)  && (BT_message[1] == 2) && (BT_message[2] == 254)){ BT_Rhythm2 = HIGH; BT_Rhythm_Count =0; BT_flag = LOW;}

      if ((BT_Rhythm3 == HIGH) &&(BT_message[1] == 3) && (BT_message[2] == 255)){ BT_Rhythm3 = LOW; Rhythm3_Nm = BT_Rhythm_Count; DefaultSet();}
      if (BT_Rhythm3 == HIGH){
        Rhythm3_Drum1[BT_Rhythm_Count] = BT_message[0];
        Rhythm3_Drum2[BT_Rhythm_Count] = BT_message[1];
        Rhythm3_Tempo[BT_Rhythm_Count] = BT_message[2];

        BT_Rhythm_Count ++;
      }
      if (( BT_message[0] == 2)  && (BT_message[1] == 3) && (BT_message[2] == 254)){ BT_Rhythm3 = HIGH; BT_Rhythm_Count =0; BT_flag = LOW;}

      if ((BT_Rhythm4 == HIGH) &&(BT_message[1] == 4) && (BT_message[2] == 255)){ BT_Rhythm4 = LOW; Rhythm4_Nm = BT_Rhythm_Count; DefaultSet();}
      if (BT_Rhythm4 == HIGH){
        Rhythm4_Drum1[BT_Rhythm_Count] = BT_message[0];
        Rhythm4_Drum2[BT_Rhythm_Count] = BT_message[1];
        Rhythm4_Tempo[BT_Rhythm_Count] = BT_message[2];

        BT_Rhythm_Count ++;
      }
      if (( BT_message[0] == 2)  && (BT_message[1] == 4) && (BT_message[2] == 254)){ BT_Rhythm4 = HIGH; BT_Rhythm_Count =0; BT_flag = LOW;}
  }
}
if (BT_flag == HIGH){ //收到藍牙訊息
  if ((BT_message[0] == 0) && (BT_message[1] == 0) && (BT_message[2] == 0)){ //回傳
    if ((Chord_count < 10) && (millis() - WatchDog >= 100)){
      WatchDog = millis();
      Serial1.write(3); Serial1.write(Chord_count); Serial1.write(Chord[Chord_count]);
      Chord_count ++;
    }

    else if(Chord_count == 10){
      Chord_count =Zero;
      //Rhythm_count =Zero;
      BT_message[0] = 255; BT_message[1] = 255; BT_message[2] = 255;
    }
  }//回傳結束
 
   if (BT_message[0] == 1){ //進入Type (1)
    if (BT_message[1] == 0){ //  Type設定為UKULELE (0)
      BT_flag = LOW;
      int Null[4] = {69,64,60,67}; 
      MIDI_5 = 50,MIDI_6 = 76, MIDI_7 = 63, MIDI_8 = 106, MIDI_9 = 46;
      BackGround = 0; //重新刷弦值
    }
    else if(BT_message[1] == 1){ //Type設定為Guitar (1)
     
      BT_flag = LOW;
      int Null[4] = {64,59,55,50}; 
      MIDI_5 = 29,MIDI_6 = 30, MIDI_7 = 27, MIDI_8 = 26, MIDI_9 = 25;
      for (int i = 0; i < 4; i++){ //重新刷弦值
        for (int j = 0; j < 17; j++){
          Array[i][j] = Null[i] + j;
        }
      }
    }
    else if(BT_message[1] == 2){ //Type設定為BASS (2)
      BT_flag = LOW;
      int Null[4] = {43,38,33,28}; 
      MIDI_5 = 35,MIDI_6 = 37, MIDI_7 = 33, MIDI_8 = 36, MIDI_9 = 42;
      for (int i = 0; i < 4; i++){ //重新刷弦值
        for (int j = 0; j < 17; j++){
          Array[i][j] = Null[i] + j;
        }
      }
    }
  } //Type End



  if (BT_message[0] == 3){ //進入Chord 
    Chord[BT_message[1]] = BT_message[2];
    if (BT_message[1] == 0){ //第一格
      chordSet(BT_message[2],FstString_1,SecString_1,ThrString_1,ForString_1);
      BT_flag = LOW;
    }
    if (BT_message[1] == 1){ //第二格
      chordSet(BT_message[2],FstString_2,SecString_2,ThrString_2,ForString_2);
      BT_flag = LOW;
    }
    if (BT_message[1] == 2){ // 第三格
      chordSet(BT_message[2],FstString_3,SecString_3,ThrString_3,ForString_3);
      BT_flag = LOW;
    }
    if (BT_message[1] == 3){ //第四格
      chordSet(BT_message[2],FstString_4,SecString_4,ThrString_4,ForString_4);
      BT_flag = LOW;
    }
    if (BT_message[1] == 4){ //第五格
      chordSet(BT_message[2],FstString_5,SecString_5,ThrString_5,ForString_5);
      BT_flag = LOW;
    }
    if (BT_message[1] == 5){ //第六格
      chordSet(BT_message[2],FstString_6,SecString_6,ThrString_6,ForString_6);
      BT_flag = LOW;
    }
    if (BT_message[1] == 6){ //第七格
      chordSet(BT_message[2],FstString_7,SecString_7,ThrString_7,ForString_7);
      BT_flag = LOW;
    }
  } //Chord END
  
} //藍牙接收END



//測試琴頸部分
//Get Neck Value
if (((Neck - VR1) > 3) && (testVR1 == HIGH)){
  Serial.println(VR1);
  Neck = VR1;
}
if (FSR1 < Trick){
  Serial.println("==VR1==");
  Neck = 1023;
  TestChange(testVR1, testVR2, testVR3, testVR4);
}

if (((Neck - VR2) > 3) && (testVR2 == HIGH)){
  Serial.println(VR2);
  Neck = VR2;
}
if (FSR2 < Trick){
  Serial.println("==VR2==");
  Neck = 1023;
  TestChange(testVR2, testVR1, testVR3, testVR4);
}

if (((Neck - VR3 ) > 3) && (testVR3 == HIGH)){
  Serial.println(VR3);
  Neck = VR3;
}
if (FSR3 < Trick){
  Serial.println("==VR3==");
  Neck = 1023;
  TestChange(testVR3, testVR1, testVR2, testVR4);
}

if (((Neck - VR4 ) > 3) && (testVR4 == HIGH)){
  Serial.println(VR4);
  Neck = VR4;
}
if (FSR4 < Trick){
  Serial.println("==VR4==");
  Neck = 1023;
  TestChange(testVR4, testVR1, testVR2, testVR3);
}



  //節奏開始
  if (Rhythm1_Flag == HIGH){
    Rhythm_Play(Rhythm1_Nm, PlayCount, PlayTime, Tempo_Speed, Rhythm1_Drum1[PlayCount], Rhythm1_Drum2[PlayCount],Rhythm1_Tempo[PlayCount]);
  }
  if (Rhythm2_Flag == HIGH){
    Rhythm_Play(Rhythm2_Nm, PlayCount, PlayTime, Tempo_Speed, Rhythm2_Drum1[PlayCount], Rhythm2_Drum2[PlayCount], Rhythm2_Tempo[PlayCount]);
  }
  if (Rhythm3_Flag == HIGH){
    Rhythm_Play(Rhythm3_Nm, PlayCount, PlayTime, Tempo_Speed, Rhythm3_Drum1[PlayCount], Rhythm3_Drum2[PlayCount], Rhythm3_Tempo[PlayCount]);
  }
  if (Rhythm4_Flag == HIGH){
    Rhythm_Play(Rhythm4_Nm, PlayCount, PlayTime, Tempo_Speed, Rhythm4_Drum1[PlayCount], Rhythm4_Drum2[PlayCount], Rhythm4_Tempo[PlayCount]);
  }



//->(FSR)Plucked Set  
//==Mode 1==//
  if (Mode == 1){  //Mode 1 : Normal
    if ((abs(FSR1 - FSR1_old) > 200) || (abs(VR1 - VR1_old) > 10)){
      if (abs(VR1 - VR1_old) > 10){
        midiSend(Ctrl,0x40,OFF);
      }
      // FSR trick & VR no trick
      if ((FSR1 < Trick) && (VR1 > 1000)){  //FSR trick && VR no trick
        SustainSet(MIDI);
        DWflag_1 = 1;
      }
      if ((FSR1 < Trick) && (VR1 < One_1)){   //FSR trick && VR trick
        SustainSet(MIDI);
        UPflag_1 = 1;
      }
      if ((FSR1 >= Trick) && (VR1 > 1000) && (UPflag_1 == 1)){  //FSR no trick && VR no trick
        midiSend(Ctrl,0x40,OFF);
        UPflag_1 = Zero;
      }
      if ((FSR1 >= Trick) && (VR1 < One_1) && (DWflag_1 == 1)){
        midiSend(Ctrl,0x40,OFF);
        DWflag_1 = Zero;
      }
      FSR1_old = FSR1;
      VR1_old = VR1;
    }
    if ((abs(FSR2 - FSR2_old) > 200) || (abs(VR2 - VR2_old) > 10)){
      if (abs(VR2 - VR2_old) > 10){
        midiSend(Ctrl,0x40,OFF);
      }
     // FSR trick & VR no trick
      if ((FSR2 < Trick) && (VR2 > 1000)){  //FSR trick && VR no trick
        SustainSet(MIDI);
        DWflag_2 = 1;
      }
      if ((FSR2 < Trick) && (VR2 < One_2)){   //FSR trick && VR trick
        SustainSet(MIDI);
        UPflag_2 = 1;
      }
      if ((FSR2 >= Trick) && (VR2 > 1000) && (UPflag_2 == 1)){  //FSR no trick && VR no trick
        midiSend(Ctrl,0x40,OFF);
        UPflag_2 = Zero;
      }
      if ((FSR2 >= Trick) && (VR2 < One_2) && (DWflag_2 == 1)){
        midiSend(Ctrl,0x40,OFF);
        DWflag_2 = Zero;
      }
      FSR2_old = FSR2;
      VR2_old = VR2;
    }
    if ((abs(FSR3 - FSR3_old) > 200) || (abs(VR3 - VR3_old) > 10)){
      if (abs(VR3 - VR3_old) > 10){
        midiSend(Ctrl,0x40,OFF);
      }
    // FSR trick & VR no trick
      if ((FSR3 < Trick) && (VR3 > 1000)){  //FSR trick && VR no trick
        SustainSet(MIDI);
        DWflag_3 = 1;
      }
      if ((FSR3 < Trick) && (VR3 < One_3)){   //FSR trick && VR trick
        SustainSet(MIDI);
        UPflag_3 = 1;
      }
      if ((FSR3 >= Trick) && (VR3 > 1000) && (UPflag_3 == 1)){  //FSR no trick && VR no trick
        midiSend(Ctrl,0x40,OFF);
        UPflag_3 = Zero;
      }
      if ((FSR3 >= Trick) && (VR3 < One_3) && (DWflag_3 == 1)){
        midiSend(Ctrl,0x40,OFF);
        DWflag_3 = Zero;
      }
      FSR3_old = FSR3;
      VR3_old = VR3;
    }
    if ((abs(FSR4 - FSR4_old) > 200) || (abs(VR4 - VR4_old) > 10)){
      if (abs(VR4 - VR4_old) > 10){
        midiSend(Ctrl,0x40,OFF);
      }
    // FSR trick & VR no trick
      if ((FSR4 < Trick) && (VR4 > 1000)){  //FSR trick && VR no trick
        SustainSet(MIDI);
        DWflag_4 = 1;
      }
      if ((FSR4 < Trick) && (VR4 < One_4)){   //FSR trick && VR trick
        SustainSet(MIDI);
        UPflag_4 = 1;
      }
      if ((FSR4 >= Trick) && (VR4 > 1000) && (UPflag_4 == 1)){  //FSR no trick && VR no trick
        midiSend(Ctrl,0x40,OFF);
        UPflag_4 = Zero;
      }
      if ((FSR4 >= Trick) && (VR4 < One_4) && (DWflag_4 == 1)){
        midiSend(Ctrl,0x40,OFF);
        DWflag_4 = Zero;
      }
      FSR4_old = FSR4;
      VR4_old = VR4;
    }
    
    if ((FSR1 < Trick) && (count_1 == Zero)){
      MelodyOn(T1,Velocity1,count_1,cut_note1,Time_1,T1_old);
    }
    else if((FSR1 >= Trick) && (millis() - Time_1 > CurrentTime) && (cut_note1 == LOW)){
      MelodyOff(T1,Velocity1,count_1,cut_note1,T1_old);
    }
  
    if ((FSR2 < Trick) && (count_2 == Zero)){
      MelodyOn(T2,Velocity2,count_2,cut_note2,Time_2,T2_old) ; 
    }
    else if((FSR2 >= Trick) && (millis() - Time_2 > CurrentTime) && (cut_note2 == LOW)){
      MelodyOff(T2,Velocity2,count_2,cut_note2,T2_old);
    }
  
    if ((FSR3 < Trick) && (count_3 == Zero)){
      MelodyOn(T3,Velocity3,count_3,cut_note3,Time_3,T3_old);
    }
    else if((FSR3 >= Trick) && (millis() - Time_3 > CurrentTime) && (cut_note3 == LOW)){
      MelodyOff(T3,Velocity3,count_3,cut_note3,T3_old);
    }
  
    if ((FSR4 < Trick) && (count_4 == Zero)){
      MelodyOn(T4,Velocity4,count_4,cut_note4,Time_4,T4_old);
    }
    else if((FSR4 >= Trick) && (millis() - Time_4 > CurrentTime) && (cut_note4 == LOW)){
      MelodyOff(T4,Velocity4,count_4,cut_note4,T4_old);
    }
  
    
}//Mode 1 End


//==Mode 2==//
  if (Mode == 2){ ///Mode 2:連續發聲
    SustainSet(MIDI);
    V1 = map(FSR1, 1023, 20, Zero, 127);
    V2 = map(FSR2, 1023, 20, Zero, 127);
    V3 = map(FSR3, 1023, 20, Zero, 127);
    V4 = map(FSR4, 1023, 20, Zero, 127);
    if ((FSR1 < Trick) && (count_1 == Zero)){
      MelodyOn(T1,V1,count_1,cut_note1,Time_1,T1_old);
    }
    else if((FSR1 >= Trick) && (millis() - Time_1 > CurrentTime) && (cut_note1 == LOW)){
      MelodyOff(T1,V1,count_1,cut_note1,T1_old);
      Mode2_1 = LOW;
    }
    if ((FSR2 < Trick) && (count_2 == Zero)){
      MelodyOn(T2,V2,count_2,cut_note2,Time_2,T2_old);
    }
    else if((FSR2 >= Trick) && (millis() - Time_2 > CurrentTime) && (cut_note2 == LOW)){
      MelodyOff(T2,V2,count_2,cut_note2,T2_old);
      Mode2_2 = LOW;
    }
    if ((FSR3 < Trick) && (count_3 == Zero)){
      MelodyOn(T3,V3,count_3,cut_note3,Time_3,T3_old);
    }
    else if((FSR3 >= Trick) && (millis() - Time_3 > CurrentTime) && (cut_note3 == LOW)){
      MelodyOff(T3,V3,count_3,cut_note3,T3_old);
      Mode2_3 = LOW;
    }  
    if ((FSR4 < Trick) && (count_4 == Zero)){
      MelodyOn(T4,V4,count_4,cut_note4,Time_4,T4_old);
    }
    else if((FSR4 >= Trick) && (millis() - Time_4 > CurrentTime) && (cut_note4 == LOW)){
      MelodyOff(T4,V4,count_4,cut_note4,T4_old);
      Mode2_4 = LOW;
    }

    if ((count_1 == 1) && (millis() - Time_1 > Mode2Trick)){
      Mode2_1 = HIGH;
    }
    if ((count_2 ==1) && (millis() - Time_2 > Mode2Trick)){
      Mode2_2 = HIGH;
    }
    if ((count_3 ==1) && (millis() - Time_3 > Mode2Trick)){
      Mode2_3 = HIGH;
    }
    if ((count_4 == 1) &&(millis() - Time_4 > Mode2Trick)){
      Mode2_4 = HIGH;
    }

     //Mode 2 Loop
    if (Mode2_1 == HIGH){
      Mode2Play(T1,V1,Time_1);
    }
    if (Mode2_2 == HIGH){
      Mode2Play(T2,V2,Time_2);
    }
    if (Mode2_3 == HIGH){
      Mode2Play(T3,V3,Time_3);
    }
    if (Mode2_4 == HIGH){
      Mode2Play(T4,V4,Time_4);
    }//Mode 2 loop end
  }///Mode 2 End

//==Mode 3==//
  if (Mode == 3){ //Mode 3 : 爬音 play
    if ((FSR1 < Trick) && (count_1 == 0)){
      Mode4_Trick(T1,Time_1,count_1,cut_note1,T1_old,Mode4_flag1); //確認按壓防彈跳
      Mode4_Note_Set(T1_old,T1_Mode4_1, T1_Mode4_2, T1_Mode4_3,Mode4_count1); //設定爬音NOTE
    }
    else if ((FSR1 >= Trick) && (cut_note1 == LOW)){ //按壓關閉
      count_1 =0;
      cut_note1 = HIGH;
    }

    if ((FSR2 < Trick) && (count_2 == 0)){
      Mode4_Trick(T2,Time_2,count_2,cut_note2,T2_old,Mode4_flag2); //確認按壓防彈跳
      Mode4_Note_Set(T2_old,T2_Mode4_1, T2_Mode4_2, T2_Mode4_3, Mode4_count2); //設定爬音NOTE
    }
    else if ((FSR2 >= Trick) && (cut_note2 == LOW)){ //按壓關閉
      count_2 =0;
      cut_note2 = HIGH;
    }

    if ((FSR3 < Trick) && (count_3 == 0)){
      Mode4_Trick(T3,Time_3,count_3,cut_note3,T3_old,Mode4_flag3); //確認按壓防彈跳
      Mode4_Note_Set(T3_old,T3_Mode4_1, T3_Mode4_2, T3_Mode4_3, Mode4_count3); //設定爬音NOTE
    }
    else if ((FSR3 >= Trick) && (cut_note3 == LOW)){ //按壓關閉
      count_3 =0;
      cut_note3 = HIGH;
    }

    if ((FSR4 < Trick) && (count_4 == 0)){
      Mode4_Trick(T4,Time_4,count_4,cut_note4,T4_old,Mode4_flag4); //確認按壓防彈跳
      Mode4_Note_Set(T4_old,T4_Mode4_1, T4_Mode4_2, T4_Mode4_3,Mode4_count4); //設定爬音NOTE
    }
    else if ((FSR4 >= Trick) && (cut_note4 == LOW)){ //按壓關閉
      count_4 =0;
      cut_note4 = HIGH;
    }


    
    if (Mode4_flag1 == HIGH){ //自動演奏
      Mode4_Play(Time_1,T1_old, T1_Mode4_1, T1_Mode4_2, T1_Mode4_3, Mode4_count1,Mode4_flag1);
    }
    if (Mode4_flag2 == HIGH){ //自動演奏
      Mode4_Play(Time_2,T2_old, T2_Mode4_1, T2_Mode4_2, T2_Mode4_3, Mode4_count2,Mode4_flag2);
    }
    if (Mode4_flag3 == HIGH){ //自動演奏
      Mode4_Play(Time_3,T3_old, T3_Mode4_1, T3_Mode4_2, T3_Mode4_3, Mode4_count3,Mode4_flag3);
    }
    if (Mode4_flag4 == HIGH){ //自動演奏
      Mode4_Play(Time_4,T4_old, T4_Mode4_1, T4_Mode4_2, T4_Mode4_3, Mode4_count4,Mode4_flag4);
    }

  }//Mode 3 End 

//==Mode 4==//
  if (Mode == 4){//Mode 4 : Body Drum
  //Close it if no PIEZO setup.(Because of Analog 11 is not stable)
    V1 = map(FSR1, 1023, 20, 0, 127);
    V2 = map(FSR2, 1023, 20, 0, 127);
    V3 = map(FSR3, 1023, 20, 0, 127);
    V4 = map(FSR4, 1023, 20, 0, 127);

    countVR4 = countVR1 = countVR2 = countVR3 = 100;
    /*
     * 如果有安裝蜂鳴片才要打開
    if(( BodyDrum >  16) && (millis() - Time_BD > BD)){  
      Time_BD = millis();
      SetBDVelocity(BodyDrum,Velocity_BD);
  //    Serial.println(BodyDrum);
      noteOn(Ch10_ON, 64, Velocity_BD); //64
      noteOn(Ch10_OFF, 64, Velocity_BD);
    }*/

    if ((FSR1 < Trick) && (count_1 == 0)){
      noteOn(Ch10_ON, 57, V1);
      count_1 ++;
      Time_1 = millis();
      cut_note1 = LOW;
    }
    else if((FSR1 >= Trick) && (millis() - Time_1 > CurrentTime) && (cut_note1 == LOW)){
      noteOn(Ch10_OFF, 57, V1);
      count_1 = 0;
      cut_note1 = HIGH;
    }
    if ((FSR2 < Trick) && (count_2 == 0)){
      noteOn(Ch10_ON, 55, V2);
      count_2 ++;
      Time_2 = millis();
      cut_note2 = LOW;
    }
    else if((FSR2 >= Trick) && (millis() - Time_2 > CurrentTime) && (cut_note2 == LOW)){
      noteOn(Ch10_OFF, 55, V2);
      count_2 = 0;
      cut_note2 = HIGH;
    }

    if ((FSR3 < Trick) && (count_3 == 0)){
      noteOn(Ch10_ON, 63, V3);
      count_3 ++;
      Time_3 = millis();
      cut_note3 = LOW;
    }
    else if((FSR3 >= Trick) && (millis() - Time_3 > CurrentTime) && (cut_note3 == LOW)){
      noteOn(Ch10_OFF, 63, V3);
      count_3 = 0;
      cut_note3 = HIGH;
    }
    
    
     if ((FSR4 < Trick) && (count_4 == 0)){
      noteOn(Ch10_ON, 61, V4);
      count_4 ++;
      Time_4 = millis();
      cut_note4 = LOW;
    }
    else if((FSR4 >= Trick) && (millis() - Time_4 > CurrentTime) && (cut_note4 == LOW)){
      noteOn(Ch10_OFF,61 , V4);
      count_4 = 0;
      cut_note4 = HIGH;
    }
  }//Mode 4 End

//==Mode 5==//
   if(Mode == 5){ //Mode 5 : Chord
    //midiSend(0xB0, 0x40, Zero); //Sustain OFF
    SustainSet(MIDI);
    if ( (T4 == Array[3][1])){
      T4 = FstString_1; T3 = SecString_1; T2=ThrString_1; T1=ForString_1; //C
    }
    if ( (T4 == Array[3][2])){
      T4 = FstString_2; T3 = SecString_2; T2=ThrString_2; T1=ForString_2; //Dm
    }
    if ((T4 == Array[3][3])){
      T4 = FstString_3; T3 = SecString_3; T2=ThrString_3; T1=ForString_3; //Em
    }
    if ((T4 == Array[3][4])){
      T4 = FstString_4; T3 = SecString_4; T2=ThrString_4; T1=ForString_4;  //F
    }
    if ((T4 == Array[3][5])){
      T4 = FstString_5; T3 = SecString_5; T2=ThrString_5; T1=ForString_5; //G
    }
    if ( (T4 == Array[3][6])){
      T4 = FstString_6; T3 = SecString_6; T2=ThrString_6; T1=ForString_6; //Am
    }
    if ( (T4 == Array[3][7])){
      T4 = FstString_7; T3 = SecString_7; T2=ThrString_7; T1=ForString_7; //B
    }
    
    if ((FSR1 < Trick) && (count_1 == Zero)){
      MelodyOn(T1,Velocity1,count_1,cut_note1,Time_1,T1_old);
    }
    else if((FSR1 >= Trick) && (millis() - Time_1 > CurrentTime) && (cut_note1 == LOW)){
      MelodyOff(T1,Velocity1,count_1,cut_note1,T1_old);
    }
  
    if ((FSR2 < Trick) && (count_2 == Zero)){
      MelodyOn(T2,Velocity2,count_2,cut_note2,Time_2,T2_old);
    }
    else if((FSR2 >= Trick) && (millis() - Time_2 > CurrentTime) && (cut_note2 == LOW)){
      MelodyOff(T2,Velocity2,count_2,cut_note2,T2_old);
    }
  
    if ((FSR3 < Trick) && (count_3 == Zero)){
      MelodyOn(T3,Velocity3,count_3,cut_note3,Time_3,T3_old);
    }
    else if((FSR3 >= Trick) && (millis() - Time_3 > CurrentTime) && (cut_note3 == LOW)){
      MelodyOff(T3,Velocity3,count_3,cut_note3,T3_old);
    }
  
    if ((FSR4 < Trick) && (count_4 == Zero)){
      MelodyOn(T4,Velocity4,count_4,cut_note4,Time_4,T4_old);
    }
    else if((FSR4 >= Trick) && (millis() - Time_4 > CurrentTime) && (cut_note4 == LOW)){
      MelodyOff(T4,Velocity4,count_4,cut_note4,T4_old);
    }
  } //Mode 5 End

}
/*====================Loop END======================================*/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


